#include "../../include/CovertChannel/ProxyChannel.h"
#include <iostream>

ProxyChannel::ProxyChannel(const std::string &innerInterface, const std::string &outerInterface, const std::string &ownIP, const std::string &partnerIP,
                           const std::string &originIP, const std::string &targetIP, const std::string &targetPort, const bool relayOnly)
    : CovertChannel(innerInterface, outerInterface, "not (tcp and src host " + originIP + " and dst host " + targetIP + " and dst port " + targetPort + ")",

                    "not (tcp and src host " + targetIP + " and dst host " + ownIP + " and src port " + targetPort + ")",

                    "tcp and src host " + originIP + " and dst host " + targetIP + " and dst port " + targetPort,

                    "tcp and src host " + targetIP + " and dst host " + ownIP + " and src port " + targetPort,

                    "tcp and src host " + partnerIP + " and dst host " + ownIP + " and dst port " + targetPort),
      relayOnly(relayOnly), ownAddress(ownIP), partnerAddress(partnerIP), originAddress(originIP), targetAddress(targetIP) {}

ProxyChannel::~ProxyChannel() {}

bool ProxyChannel::handleChannelFromOuter(Tins::PDU &pdu) {
	// TODO: check in a list how to route it and who send the request for this answer

	Tins::IP &ip = pdu.rfind_pdu<Tins::IP>();
	if (relayOnly) {
		// redirect to partner
		ip.src_addr(ownAddress);
		ip.dst_addr(partnerAddress);
		outerSender.send(pdu);
	} else {
		ip.src_addr(targetAddress);
		ip.dst_addr(originAddress);
		innerSender.send(pdu);
		std::cout << "channel from outer" << std::endl;
	}
	return true;
}

bool ProxyChannel::handleChannelFromInner(Tins::PDU &pdu) {
	Tins::IP &ip = pdu.rfind_pdu<Tins::IP>();
	if (relayOnly) {
		std::cerr << "Fixme: packet cannot be routed back so it's dropped here!!!" << std::endl;
		// outerSender.send(pdu);
		// TODO: add pdu to a list to check later how to route it
	} else {
		ip.src_addr(ownAddress);
		ip.dst_addr(partnerAddress);
		outerSender.send(pdu);
		std::cout << "channel from inner" << std::endl;
	}
	return true;
}

bool ProxyChannel::handlePartnerFromOuter(Tins::PDU &pdu) {
	Tins::IP &ip = pdu.rfind_pdu<Tins::IP>();
	if (relayOnly) {
		// redirect to partner
		ip.src_addr(ownAddress);
		ip.dst_addr(targetAddress);
		outerSender.send(pdu);
		std::cout << "relay" << std::endl;
	} else {
		// should already be addressed right
		ip.src_addr(targetAddress);
		ip.dst_addr(originAddress);
		innerSender.send(pdu);
		std::cout << "partner" << std::endl;
	}
	return true;
}
